> ## Documentation Index
> Fetch the complete documentation index at: https://stytch.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Send Discovery OTP

> Send a discovery OTP to an email address using the Stytch B2B API

Send a discovery OTP to an email address. The OTP is valid for 10 minutes.

Only the most recently sent OTP is valid: when an OTP is sent, all OTPs previously sent to the same email address are invalidated, even if unused or unexpired.


## OpenAPI

````yaml POST /v1/b2b/otps/email/discovery/send
openapi: 3.0.3
info:
  title: Stytch API
  description: The Stytch API provides endpoints for authentication and user management.
  version: 2.1.1
  contact:
    name: Stytch Support
    url: https://stytch.com/docs
    email: support@stytch.com
servers:
  - url: https://api.stytch.com
    description: Production server
  - url: https://test.stytch.com
    description: Test server
security:
  - basicAuth: []
paths:
  /v1/b2b/otps/email/discovery/send:
    post:
      tags:
        - Email
      summary: Send
      description: >-
        Send a discovery OTP to an email address. The OTP is valid for 10
        minutes. Only the most recently sent OTP is valid: when an OTP is sent,
        all OTPs previously sent to the same email address are invalidated, even
        if unused or unexpired.
      operationId: api_b2b_otp_v1_b2b_otp_email_discovery_Send
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/api_b2b_otp_v1_b2b_otp_email_discovery_SendRequest
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api_b2b_otp_v1_b2b_otp_email_discovery_SendResponse
        '400':
          description: Bad request
        '401':
          description: Unauthorized
          content:
            application/json:
              example:
                status_code: 401
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: unauthorized_credentials
                error_message: Unauthorized credentials.
                error_url: https://stytch.com/docs/api/errors/401
        '429':
          description: Too Many Requests
          content:
            application/json:
              example:
                status_code: 429
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: too_many_requests
                error_message: Too many requests have been made.
                error_url: https://stytch.com/docs/api/errors/429
        '500':
          description: Internal server error
          content:
            application/json:
              example:
                status_code: 500
                request_id: request-id-test-b05c992f-ebdc-489d-a754-c7e70ba13141
                error_type: internal_server_error
                error_message: >-
                  Oops, something seems to have gone wrong, please reach out to
                  support@stytch.com to let us know what went wrong.
                error_url: https://stytch.com/docs/api/errors/500
      x-code-samples:
        - lang: csharp
          label: C#
          source: |-
            // POST /v1/b2b/otps/email/discovery/send
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              email_address: "sandbox@stytch.com",
            };

            client.OTPs.Email.Discovery.Send(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: go
          label: Go
          source: "// POST /v1/b2b/otps/email/discovery/send\npackage main\n\nimport (\n\t\"context\"\n\t\"log\"\n\n\t\"github.com/stytchauth/stytch-go/v18/stytch/b2b/b2bstytchapi\"\n\t\"github.com/stytchauth/stytch-go/v18/stytch/b2b/otp/email/discovery\"\n)\n\nfunc main() {\n\tclient, err := b2bstytchapi.NewClient(\n\t\t\"${projectId}\",\n\t\t\"${secret}\",\n\t)\n\tif err != nil {\n\t\tlog.Fatalf(\"error instantiating client: %v\", err)\n\t}\n\n\tparams := &discovery.SendParams{\n\t\tEmailAddress: \"sandbox@stytch.com\",\n\t}\n\n\tresp, err := client.OTPs.Email.Discovery.Send(context.Background(), params)\n\tif err != nil {\n\t\tlog.Fatalf(\"error in method call: %v\", err)\n\t}\n\n\tlog.Println(resp)\n}\n"
        - lang: java
          label: Java
          source: |-
            // POST /v1/b2b/otps/email/discovery/send
            package com.example;

            import com.stytch.java.b2b.models.otpemaildiscovery.SendRequest;
            import com.stytch.java.b2b.StytchB2BClient;
            import com.stytch.java.common.StytchResult;

            public class Main {
                public static void main(String[] args) {
                    StytchB2BClient.configure("${projectId}", "${secret}");

                    SendRequest params = new SendRequest();
                    params.setEmailAddress("sandbox@stytch.com");

                    Object result = StytchB2BClient.getOTPs().getEmail().getDiscovery().send(params);
                    if (result instanceof StytchResult.Success) {
                      System.out.println(((StytchResult.Success) result).getValue());
                    } else {
                      System.out.println(((StytchResult.Error) result).getException());
                    }
                }
            }
        - lang: kotlin
          label: Kotlin
          source: |
            // POST /v1/b2b/otps/email/discovery/send
            package com.example

            import com.stytch.java.b2b.StytchB2BClient
            import com.stytch.java.b2b.models.otpemaildiscovery.SendRequest

            fun main() {
                StytchB2BClient.configure(
                    projectId = "${projectId}",
                    secret = "${secret}",
                )

                when (
                    val result =
                        StytchB2BClient.otps.email.discovery.send(
                            SendRequest(
                                emailAddress = "sandbox@stytch.com",
                            ),
                        )
                ) {
                    is StytchResult.Success -> println(result.value)
                    is StytchResult.Error -> println(result.exception)
                }
            }
        - lang: javascript
          label: Node.js
          source: |-
            // POST /v1/b2b/otps/email/discovery/send
            const stytch = require('stytch');

            const client = new stytch.B2BClient({
              project_id: '${projectId}',
              secret: '${secret}',
            });

            const params = {
              email_address: "sandbox@stytch.com",
            };

            client.otps.email.discovery.send(params)
              .then(resp => { console.log(resp) })
              .catch(err => { console.log(err) });
        - lang: php
          label: PHP
          source: |-
            $response = $client->otps->email->discovery->send([
                'email_address' => 'sandbox@stytch.com',
            ]);
        - lang: python
          label: Python
          source: |
            # POST /v1/b2b/otps/email/discovery/send
            from stytch import B2BClient

            client = B2BClient(
                project_id="${projectId}",
                secret="${secret}",
            )

            resp = client.otps.email.discovery.send(
                email_address="sandbox@stytch.com",
            )

            print(resp)
        - lang: ruby
          label: Ruby
          source: |-
            # frozen_string_literal: true

            # POST /v1/b2b/otps/email/discovery/send
            require 'stytch'

            client = StytchB2B::Client.new(
              project_id: "${projectId}",
              secret: "${secret}"
            )

            resp = client.otps.email.discovery.send(
              email_address: "sandbox@stytch.com"
              
            )

            puts resp
        - lang: rust
          label: Rust
          source: |-
            // POST /v1/b2b/otps/email/discovery/send
            use stytch::b2b::client::Client;
            use stytch::b2b::otp_email_discovery::SendRequest;

            fn main() {
                let client = Client::new("${projectId}", "${secret}").unwrap();
                let resp = client.otps.email.discovery.send(
                    SendRequest{
                        email_address: "sandbox@stytch.com",
                        ..Default::default()
                    }
                ).await;
                println!("The response is {:?}", resp);
            }
        - lang: bash
          label: cURL
          source: |-
            # POST /v1/b2b/otps/email/discovery/send
            curl --request POST \
              --url https://test.stytch.com/v1/b2b/otps/email/discovery/send \
              -u '${projectId}:${secret}' \
              -H 'Content-Type: application/json' \
              -d '{
                "email_address": "sandbox@stytch.com"
              }'
components:
  schemas:
    api_b2b_otp_v1_b2b_otp_email_discovery_SendRequest:
      type: object
      properties:
        email_address:
          type: string
          description: The email address to start the discovery flow for.
        login_template_id:
          type: string
          description: >-
            Use a custom template for login emails. By default, it will use your
            default email template. Templates can be added in the [Stytch
            dashboard](https://stytch.com/dashboard/templates) using our
            built-in customization options or custom HTML templates with type
            “OTP - Login”.
        locale:
          $ref: >-
            #/components/schemas/api_b2b_otp_v1_otp_email_discovery_SendRequestLocale
          description: >-
            Used to determine which language to use when sending the user this
            delivery method. Parameter is an [IETF BCP 47 language
            tag](https://www.w3.org/International/articles/language-tags/), e.g.
            `"en"`.


            If no value is provided, the copy defaults to English.
        discovery_expiration_minutes:
          type: integer
          format: int32
          minimum: 0
          description: >-
            The expiration time, in minutes, for a discovery OTP email. If not
            accepted within this time frame, the OTP will need to be resent.
            Defaults to 10 with a minimum of 2 and a maximum of 15.
      description: Request type
      required:
        - email_address
    api_b2b_otp_v1_b2b_otp_email_discovery_SendResponse:
      type: object
      properties:
        request_id:
          type: string
          description: >-
            Globally unique UUID that is returned with every API call. This
            value is important to log for debugging purposes; we may ask for
            this value to help identify a specific API call when helping you
            debug an issue.
        status_code:
          type: integer
          format: int32
          description: >-
            The HTTP status code of the response. Stytch follows standard HTTP
            response status code patterns, e.g. 2XX values equate to success,
            3XX values are redirects, 4XX are client errors, and 5XX are server
            errors.
      required:
        - request_id
        - status_code
    api_b2b_otp_v1_otp_email_discovery_SendRequestLocale:
      type: string
      enum:
        - en
        - es
        - pt-br
        - fr
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic

````